Index: /XIOS/dev/dev_olga/src/node/domain.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/domain.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/domain.cpp	(revision 1129)
@@ -2743,36 +3011,53 @@
     }
    
-    int nbCompressedData = 0; 
+    int nbIndex = i_index.numElements();
+    CArray<int,1> dataIIndex(nbIndex), dataJIndex(nbIndex);
+    dataIIndex = -1; dataJIndex = -1;
+
+    nbIndex = 0;
     for (i = 0; i < nbReceived; ++i)
+    {      
+      CArray<int,1>& tmpInd = indGlob_[recvClientRanks_[i]];
+      CArray<int,1>& tmpI = recvDataIIndex[i];    
+      CArray<int,1>& tmpJ = recvDataJIndex[i];     
+      if ((tmpI.numElements() != tmpInd.numElements()) || (tmpJ.numElements() != tmpInd.numElements()))
+          ERROR("void CDomain::recvDataIndex(std::map<int, CBufferIn*>& rankBuffers)",
+             << "The number of global received index is not coherent with the number of received data index."
+             << "Expected number of global index: " << tmpI.numElements() << " but received " << tmpInd.numElements());
+
+      for (ind = 0; ind < tmpI.numElements(); ++ind)
+      {
+         lInd = globalLocalIndexMap_[size_t(tmpInd(ind))];
+         dataIIndex(lInd) = tmpI(ind);
+         dataJIndex(lInd) = tmpJ(ind);         
+      } 
+    }
+
+    int nbCompressedData = 0;  
+    for (ind = 0; ind < dataIIndex.numElements(); ++ind)
     {
-      CArray<int,1>& tmp = recvDataIIndex[i];
-      for (ind = 0; ind < tmp.numElements(); ++ind)
-      {
-         index = tmp(ind);
-         if (0 <= index)
-           ++nbCompressedData;
-      }        
-    }
-
+       indexI = dataIIndex(ind); indexJ = dataJIndex(ind);
+       if ((0 <= indexI) && (0 <= indexJ))
+         ++nbCompressedData;
+    }        
+  
     data_i_index.resize(nbCompressedData);
     data_j_index.resize(nbCompressedData);
 
-    nbCompressedData = 0;
-    for (i = 0; i < nbReceived; ++i)
+    nbCompressedData = 0;  
+    for (ind = 0; ind < dataIIndex.numElements(); ++ind)
     {
-      CArray<int,1>& tmpI = recvDataIIndex[i];      
-      CArray<int,1>& tmpIndex = indGlob_[recvClientRanks_[i]];
-      for (ind = 0; ind < tmpI.numElements(); ++ind)
-      {
-         indexI = tmpI(ind);
-         index  = tmpIndex(ind);
-         if (0 <= indexI)
-         {
-          data_i_index(nbCompressedData) = index % ni_glo - ibegin;
-          data_j_index(nbCompressedData) = index / ni_glo - jbegin;
-          ++nbCompressedData;
-         }         
-      } 
-    }
+       indexI = dataIIndex(ind); indexJ = dataJIndex(ind);
+       if ((0 <= indexI) && (0 <= indexJ))
+       {
+          data_i_index(nbCompressedData) = (1 == data_dim) ? ind : i_index(ind) - i_index(0);
+          data_j_index(nbCompressedData) = (1 == data_dim) ? 0   : j_index(ind) - j_index(0);  
+         ++nbCompressedData;
+       }
+    }
+
+    // Reset data_ibegin, data_jbegin
+    data_ibegin.setValue(0);
+    data_jbegin.setValue(0);
   }
 
Index: /XIOS/dev/dev_olga/src/node/domain.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/domain.hpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/domain.hpp	(revision 1129)
@@ -51,5 +51,6 @@
            EVENT_ID_INDEX, EVENT_ID_LON, EVENT_ID_LAT, 
            EVENT_ID_AREA, EVENT_ID_MASK,
-           EVENT_ID_DATA_INDEX, EVENT_ID_SERVER_ATTRIBUT
+           EVENT_ID_DATA_INDEX, EVENT_ID_SERVER_ATTRIBUT,
+           EVENT_ID_INDEX_ZOOM
          } ;
 
@@ -106,4 +107,5 @@
 
          std::map<int, StdSize> getAttributesBufferSize();
+         CArray<size_t,1> localIndexToWriteOnServer;
 
          bool isEmpty(void) const;
@@ -127,4 +129,5 @@
          void completeLonLatClient(void);         
          void computeConnectedClients();
+         void computeWrittenIndex();
 
          void AllgatherRectilinearLonLat(CArray<double,1>& lon, CArray<double,1>& lat,
@@ -138,4 +141,5 @@
          static void recvDistributionAttributes(CEventServer& event);
          static void recvIndex(CEventServer& event);
+         static void recvIndexZoom(CEventServer& event);
          static void recvMask(CEventServer& event);
          static void recvZoom(CEventServer& event);
@@ -144,7 +148,7 @@
          static void recvArea(CEventServer& event);
          static void recvDataIndex(CEventServer& event);
-         void recvDistributionAttributes(CBufferIn& buffer);         
-         void recvZoom(std::vector<int>& rank, std::vector<CBufferIn*>& buffers);
+         void recvDistributionAttributes(CBufferIn& buffer);                  
          void recvIndex(std::map<int, CBufferIn*>& rankBuffers);
+         void recvIndexZoom(std::map<int, CBufferIn*>& rankBuffers);
          void recvMask(std::map<int, CBufferIn*>& rankBuffers);
          void recvLon(std::map<int, CBufferIn*>& rankBuffers);
@@ -192,6 +196,8 @@
          void sendArea();
          void sendLonLat();
-         void sendZoom();
+         void sendIndexZoom();
          void sendDataIndex();
+
+         void convertLonLatValue();
 
        private:         
@@ -202,9 +208,9 @@
 
          bool doZoomByIndex_;
-         bool isChecked;
+         bool isChecked, computedWrittenIndex_;
          std::set<StdString> relFiles, relFilesCompressed;
          bool isClientChecked; // Verify whether all attributes of domain on the client side are good
          bool isClientAfterTransformationChecked;
-         std::map<int, CArray<int,1> > indiSrv, indjSrv, indGlob_;
+         std::map<int, CArray<int,1> > indiSrv, indjSrv, indGlob_, indGlobZoom_;
          std::map<int,int> nbConnectedClients_, nbConnectedClientsZoom_; // Mapping of number of communicating client to a server
 
@@ -213,7 +219,7 @@
          std::map<int, vector<int> > indWrittenSrv_; // Global written index of each client sent to server
          std::vector<int> indexesToWrite;
-         std::vector<int> recvClientRanks_;
+         std::vector<int> recvClientRanks_, recvClientZoomRanks_;
          int numberWrittenIndexes_, totalNumberWrittenIndexes_, offsetWrittenIndexes_;
-         std::vector<int> connectedServerRank_;
+         std::vector<int> connectedServerRank_, connectedServerZoomRank_;
          bool isDistributed_;
          //! True if and only if the data defined on the domain can be outputted in a compressed way
@@ -222,5 +228,5 @@
          TransMapTypes transformationMap_;         
          bool isUnstructed_;
-         boost::unordered_map<size_t,size_t> globalLocalIndexMap_;
+         boost::unordered_map<size_t,size_t> globalLocalIndexMap_, globalLocalIndexZoomMap_;
        
        private:
Index: /XIOS/dev/dev_olga/src/node/field.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/field.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/field.cpp	(revision 1129)
@@ -35,5 +35,6 @@
       , nstep(0), nstepMax(0)
       , hasOutputFile(false)
-      , domAxisScalarIds_(vector<StdString>(3,"")), areAllReferenceSolved(false), isReferenceSolved(false)
+      , domAxisScalarIds_(vector<StdString>(3,""))
+      , areAllReferenceSolved(false), isReferenceSolved(false), isReferenceSolvedAndTransformed(false)
       , useCompressedOutput(false)
       , wasDataAlreadyReceivedFromServer(false)
@@ -46,5 +47,6 @@
       , nstep(0), nstepMax(0)
       , hasOutputFile(false)
-      , domAxisScalarIds_(vector<StdString>(3,"")), areAllReferenceSolved(false), isReferenceSolved(false)
+      , domAxisScalarIds_(vector<StdString>(3,""))
+      , areAllReferenceSolved(false), isReferenceSolved(false), isReferenceSolvedAndTransformed(false)
       , useCompressedOutput(false)
       , wasDataAlreadyReceivedFromServer(false)
@@ -257,13 +259,21 @@
     size_t sizeData = 0;
     if (0 == recvDataSrv.numElements())
-    {      
-      for (map<int, CArray<size_t, 1> >::iterator it = grid->outIndexFromClient.begin(); it != grid->outIndexFromClient.end(); ++it)
-      {
-        sizeData += it->second.numElements();
-        data_srv.insert(std::make_pair(it->first, CArray<double,1>(it->second.numElements())));
-      }
+    {            
+      CArray<int,1>& storeClient = grid->storeIndex_client;
+      // for (map<int, CArray<size_t, 1> >::iterator it = grid->outIndexFromClient.begin(); it != grid->outIndexFromClient.end(); ++it)
+      // {
+      //   // sizeData += it->second.numElements();
+      //   data_srv.insert(std::make_pair(it->first, CArray<double,1>(it->second.numElements())));
+      // }
+
+      // for (map<int, CArray<size_t, 1> >::iterator it = grid->outLocalIndexStoreOnClient.begin(); it != grid->outLocalIndexStoreOnClient.end(); ++it)
+      // {
+      //   // sizeData += it->second.numElements();
+      //   data_srv.insert(std::make_pair(it->first, CArray<double,1>(it->second.numElements())));
+      // }
 
       // Gather all data from different clients
-      recvDataSrv.resize(sizeData);
+      // recvDataSrv.resize(sizeData);
+      recvDataSrv.resize(storeClient.numElements());
       recvFoperationSrv = boost::shared_ptr<func::CFunctor>(new func::CInstant(recvDataSrv));
     }
@@ -276,6 +286,6 @@
     if (opeDate <= currDate)
     {
-      for (map<int, CArray<size_t, 1> >::iterator it = grid->outIndexFromClient.begin(); it != grid->outIndexFromClient.end(); ++it)
-      {        
+       for (map<int, CArray<size_t, 1> >::iterator it = grid->outLocalIndexStoreOnClient.begin(); it != grid->outLocalIndexStoreOnClient.end(); ++it)
+      {
         CArray<double,1> tmp;
         CArray<size_t,1>& indexTmp = it->second;
@@ -288,4 +298,17 @@
         // sizeData += it->second.numElements();      
       }
+
+      // for (map<int, CArray<size_t, 1> >::iterator it = grid->outIndexFromClient.begin(); it != grid->outIndexFromClient.end(); ++it)
+      // {        
+      //   CArray<double,1> tmp;
+      //   CArray<size_t,1>& indexTmp = it->second;
+      //   *(rankBuffers[it->first]) >> tmp;
+      //   for (int idx = 0; idx < indexTmp.numElements(); ++idx)
+      //   {
+      //     recv_data_tmp(indexTmp(idx)) = tmp(idx);
+      //   }
+      //   // recv_data_tmp(Range(sizeData,sizeData+it->second.numElements()-1)) = tmp;  
+      //   // sizeData += it->second.numElements();      
+      // }
     }
 
@@ -316,4 +339,5 @@
       recvFoperationSrv->final();
       last_Write_srv = writeDate;
+      grid->computeWrittenIndex();
       writeField();
       lastlast_Write_srv = last_Write_srv;
@@ -813,5 +837,9 @@
    }
    
-   void CField::solveAllEnabledFields()
+   /*!
+     Solve reference of all enabled fields even the source fields .
+     In this step, we do transformations.
+   */
+   void CField::solveAllEnabledFieldsAndTransform()
    {
      CContext* context = CContext::getCurrent();
@@ -819,12 +847,12 @@
      bool hasServer = context->hasServer;
 
-     if (!isReferenceSolved)
-     {
-        isReferenceSolved = true;
+     if (!isReferenceSolvedAndTransformed)
+     {
+        isReferenceSolvedAndTransformed = true;
 
         if (hasClient && !hasServer)
         {
           solveRefInheritance(true);
-          if (hasDirectFieldReference()) getDirectFieldReference()->solveAllEnabledFields();
+          if (hasDirectFieldReference()) getDirectFieldReference()->solveAllEnabledFieldsAndTransform();
         }
 
@@ -992,5 +1020,5 @@
    {
      // if (!areAllReferenceSolved) solveAllReferenceEnabledField(false);
-    if (!isReferenceSolved) solveAllEnabledFields();
+    if (!isReferenceSolvedAndTransformed) solveAllEnabledFieldsAndTransform();
      CContext* context = CContext::getCurrent();
      bool hasWriterServer = context->hasServer && !context->hasClient;
@@ -1428,8 +1456,13 @@
    void CField::outputField(CArray<double,1>& fieldOut)
    {
-      map<int, CArray<double,1> >::iterator it;
-      
-      fieldOut = recvDataSrv;
-      
+      map<int, CArray<double,1> >::iterator it;      
+     
+      CArray<size_t,1>& outIndexClient = grid->localIndexToWriteOnClient;
+      CArray<size_t,1>& outIndexServer = grid->localIndexToWriteOnServer;
+      for (size_t idx = 0; idx < outIndexServer.numElements(); ++idx)
+      {
+        fieldOut(outIndexServer(idx)) = recvDataSrv(outIndexClient(idx));
+      }
+
       // for (it = data_srv.begin(); it != data_srv.end(); it++)
       // {
Index: /XIOS/dev/dev_olga/src/node/field.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/field.hpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/field.hpp	(revision 1129)
@@ -122,5 +122,5 @@
          void solveGridDomainAxisBaseRef();
 
-         void solveAllEnabledFields();
+         void solveAllEnabledFieldsAndTransform();
          void checkGridOfEnabledFields();
          void sendGridOfEnabledFields();
@@ -216,6 +216,4 @@
          string content;
 
-         bool areAllReferenceSolved;
-         bool isReferenceSolved;
          std::vector<StdString> domAxisScalarIds_;
          bool useCompressedOutput;
@@ -225,5 +223,11 @@
          bool hasTimeCentered;
 
+
          DECLARE_REF_FUNC(Field,field)
+
+      private:
+         bool areAllReferenceSolved;
+         bool isReferenceSolved;
+         bool isReferenceSolvedAndTransformed;
 
       private:
Index: /XIOS/dev/dev_olga/src/node/file.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/file.cpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/file.cpp	(revision 1129)
@@ -695,6 +695,6 @@
      for (int i = 0; i < size; ++i)
      {
-       // this->enabledFields[i]->solveOnlyReferenceEnabledField(sendToServer);
-       this->enabledFields[i]->solveAllEnabledFields();
+       this->enabledFields[i]->solveOnlyReferenceEnabledField(sendToServer);
+       // this->enabledFields[i]->solveAllEnabledFields();
 //       this->enabledFields[i]->buildGridTransformationGraph();
      }
@@ -736,10 +736,11 @@
    \param [in] sendToServer: Send all info to server (true) or only a part of it (false)
    */
-   void CFile::solveAllRefOfEnabledFields(bool sendToServer)
+   void CFile::solveAllRefOfEnabledFieldsAndTransform(bool sendToServer)
    {
      int size = this->enabledFields.size();
      for (int i = 0; i < size; ++i)
      {
-       this->enabledFields[i]->solveAllReferenceEnabledField(sendToServer);
+       // this->enabledFields[i]->solveAllReferenceEnabledField(sendToServer);
+      this->enabledFields[i]->solveAllEnabledFieldsAndTransform();
      }
    }
Index: /XIOS/dev/dev_olga/src/node/file.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/file.hpp	(revision 1128)
+++ /XIOS/dev/dev_olga/src/node/file.hpp	(revision 1129)
@@ -105,9 +105,10 @@
          void solveOnlyRefOfEnabledFields(bool sendToServer);
          void generateNewTransformationGridDest();
-         void solveAllRefOfEnabledFields(bool sendToServer);
+         
          void buildFilterGraphOfEnabledFields(CGarbageCollector& gc);
          void prefetchEnabledReadModeFields();
          void prefetchEnabledReadModeFieldsIfNeeded();
 
+         void solveAllRefOfEnabledFieldsAndTransform(bool sendToServer);
          void checkGridOfEnabledFields();
          void sendGridOfEnabledFields();
